// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _LIBGDAMM_HANDLERBOOLEAN_H
#define _LIBGDAMM_HANDLERBOOLEAN_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

// -*- C++ -*- //

/* handlerboolean.h
 *
 * Copyright 2006 libgdamm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>
#include <libgdamm/datahandler.h>
#include <libgda/handlers/gda-handler-boolean.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaHandlerBoolean GdaHandlerBoolean;
typedef struct _GdaHandlerBooleanClass GdaHandlerBooleanClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Gnome
{

namespace Gda
{ class HandlerBoolean_Class; } // namespace Gda

} // namespace Gnome
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Gnome
{

namespace Gda
{

/** Default Handler for booleans.
 * 
 * @ingroup DataHandlers
 */

class HandlerBoolean : public Glib::Object,
                       public DataHandler
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef HandlerBoolean CppObjectType;
  typedef HandlerBoolean_Class CppClassType;
  typedef GdaHandlerBoolean BaseObjectType;
  typedef GdaHandlerBooleanClass BaseClassType;

  // noncopyable
  HandlerBoolean(const HandlerBoolean&) = delete;
  HandlerBoolean& operator=(const HandlerBoolean&) = delete;

private:  friend class HandlerBoolean_Class;
  static CppClassType handlerboolean_class_;

protected:
  explicit HandlerBoolean(const Glib::ConstructParams& construct_params);
  explicit HandlerBoolean(GdaHandlerBoolean* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  HandlerBoolean(HandlerBoolean&& src) noexcept;
  HandlerBoolean& operator=(HandlerBoolean&& src) noexcept;

  virtual ~HandlerBoolean() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaHandlerBoolean*       gobj()       { return reinterpret_cast<GdaHandlerBoolean*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaHandlerBoolean* gobj() const { return reinterpret_cast<GdaHandlerBoolean*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GdaHandlerBoolean* gobj_copy();

private:

  
protected:

 HandlerBoolean();

public:
  
  static Glib::RefPtr<HandlerBoolean> create();


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Gda::HandlerBoolean
   */
  Glib::RefPtr<Gnome::Gda::HandlerBoolean> wrap(GdaHandlerBoolean* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_HANDLERBOOLEAN_H */

